LeetCode 1.两数之和

给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。

你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。

示例:

给定 nums = [2, 7, 11, 15], target = 9

因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]

解法1:暴力法

class Solution {
    public int[] twoSum(int[] nums, int target) {
        int []a = new int[2];
        for(int i = 0; i < nums.length; i++) {
            for(int j = i + 1; j < nums.length; j++) {
                if(nums[i] + nums[j] == target) {
                    a[0] = i;
                    a[1] = j;
                     return a;
                }
            }
        }
       return null;
    }
}

执行用时:23ms
内存消耗:38

解法2:遍历哈希表(参考)
思路:对数组进行一次遍历,每次遍历时就计算target和数组nums[i]的差值,然后到HashMap中查找该差值是否存在,如果存在,则成功找到,如不存在,则把nums[i]和i存入HashMap中

class Solution {
    public int[] twoSum(int[] nums, int target) {
        int []a = new int[2];
        Map<Integer, Integer> map = new HashMap<>();

        for(int i = 0; i < nums.length; i++) {
            int tar = target - nums[i];
            if(map.get(tar) != null) {
                a[0] = map.get(tar);
                a[1] = i;
                return a;
            }
            map.put(nums[i], i);
        }
        return null;
    }
}

执行用时:3ms
内存消耗:37.4
总结:虽然在该题中使用HashMap之后时间复杂度确实减少了很多,但是应该考虑HaspMap中get()和put()方法也需要一定的时间复杂度.

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值